'use strict'
const co = require('co')
const prompt = require('co-prompt')
// const config = require('../templates')
const chalk = require('chalk')
const fs = require('fs')
var inTplData = require('../templates')	//用户输入模板信息

module.export = co(function *(){
	var tplName = yield prompt(chalk.blue.bold('Template name:'));

	if(inTplData.tpl[tplName]){
		console.log(chalk.red('Template name has already existed!'));
		process.exit();		
	}
	else {
		var gitUrl = yield prompt(chalk.blue.bold('Git url of template:'));
		var author = yield prompt(chalk.blue.bold('Author:'));
		var version = yield prompt(chalk.blue.bold('Version:'));
		var branch = yield prompt(chalk.blue.bold('Branch:'));
		inTplData.tpl[tplName] = {};
		inTplData.tpl[tplName]['url'] = gitUrl.replace(/[\u0000-\u0019]/g, '');
		inTplData.tpl[tplName]['branch'] = branch;
	}

	fs.writeFile(__dirname + '/../templates.json', JSON.stringify(inTplData), (err) => {
		if (err) {
			console.log(chalk.red(err));
			console.log(chalk.grey('The last template list is : \n'));
			console.log(inTplData);
			console.log('\n');
			process.exit();
		}
		else{
			console.log(chalk.green('New template added!'));
			process.exit();
		}
	})
})


